=== modified file 'shell.py'
--- shell.py	2005-11-01 14:50:37 +0000
+++ shell.py	2005-11-15 18:14:05 +0000
@@ -40,14 +40,35 @@
         self.arg_pos = None
 
     def get_completions(self):
-        if not command:
-            iter = (c for c in iter_command_names() if
+        try:
+            return self.get_completions_or_raise()
+        except Exception, e:
+            print e, type(e)
+            return []
+
+    def get_option_completions(self):
+        try:
+            command_obj = get_cmd_object(self.command)
+        except BzrError:
+            return []
+        opts = [o+" " for o in iter_opt_completions(command_obj)]
+        return list(filter_completions(opts, self.text))
+
+    def get_completions_or_raise(self):
+        if self.command is None:
+            iter = (c+" " for c in iter_command_names() if
                     c not in COMPLETION_BLACKLIST)
-            try:
-                iter = list(filter_completions(iter, text))
-            except Exception, e:
-                print e, type(e)
-
+            return list(filter_completions(iter, self.text))
+        if self.prev_opt is None:
+            completions = self.get_option_completions()
+            if self.command == "cd":
+                iter = iter_dir_completions(self.text)
+                completions.extend(list(filter_completions(iter, self.text)))
+            else:
+                iter = iter_file_completions(self.text)
+                completions.extend([f+" " for f in 
+                                    filter_completions(iter, self.text)])
+            return completions 
 
 
 class PromptCmd(cmd.Cmd):
@@ -161,19 +182,7 @@
 
 
     def completenames(self, text, line, begidx, endidx):
-        from bzrlib.trace import mutter
-        completions = []
-        iter = (c for c in iter_command_names() if
-                c not in COMPLETION_BLACKLIST)
-        try:
-            if len(line) > 0:
-                arg = line.split()[-1]
-            else:
-                arg = ""
-            iter = filter_completions(iter, arg)
-        except Exception, e:
-            print e, type(e)
-        return list(iter)
+        return CompletionContext(text).get_completions()
 
     def completedefault(self, text, line, begidx, endidx):
         """Perform completion for native commands.
@@ -189,35 +198,8 @@
         """
         (cmd, args, foo) = self.parseline(line)
         if cmd == "bzr":
-            try:
-                return self.completenames(text, line, begidx, endidx)
-            except Exception, e:
-                print e
-        try:
-            command_obj = get_cmd_object(cmd)
-        except BzrError:
-            command_obj = None
-        try:
-            if command_obj is not None:
-                opts = list(iter_opt_completions(command_obj))
-                files = list(iter_file_completions(text))
-                return list(filter_completions(opts+files, text))
-            elif cmd == "cd":
-                if len(args) > 0:
-                    arg = args.split()[-1]
-                else:
-                    arg = ""
-                iter = iter_dir_completions(text)
-                iter = filter_completions(iter, text)
-                return list(iter)
-            elif len(args)>0:
-                arg = args.split()[-1]
-                iter = iter_file_completions(arg)
-                return list(iter_munged_completions(iter, arg, text))
-            else:
-                return self.completenames(text, line, begidx, endidx)
-        except Exception, e:
-            print e
+            cmd = None
+        return CompletionContext(text, command=cmd).get_completions()
 
 def run_shell():
     try:

